From 2b42f82c9a94b2fe22653b7b75374e144a9ebf26 Mon Sep 17 00:00:00 2001
From: Ilya Shpigor <shpigor@etersoft.ru>
Date: Thu, 14 May 2009 15:19:42 +0400
Subject: [PATCH] comctl32: Change the sequence of parent notification for treeview control (eterbug #2353)

---
 dlls/comctl32/treeview.c |   11 ++++++++---
 1 files changed, 8 insertions(+), 3 deletions(-)

diff --git a/dlls/comctl32/treeview.c b/dlls/comctl32/treeview.c
index c6d89c0..18e36c7 100644
--- a/dlls/comctl32/treeview.c
+++ b/dlls/comctl32/treeview.c
@@ -3156,7 +3156,7 @@ TREEVIEW_Collapse(TREEVIEW_INFO *infoPtr, TREEVIEW_ITEM *wineItem,
     if (!(wineItem->state & TVIS_EXPANDED))
 	return FALSE;
 
-    if (bUser && !(wineItem->state & TVIS_EXPANDEDONCE))
+    if (bUser || !(wineItem->state & TVIS_EXPANDEDONCE))
 	TREEVIEW_SendExpanding(infoPtr, wineItem, action);
 
     if (wineItem->firstChild == NULL)
@@ -3291,8 +3291,6 @@ TREEVIEW_Expand(TREEVIEW_INFO *infoPtr, TREEVIEW_ITEM *wineItem,
             return FALSE;
 
 	wineItem->state |= TVIS_EXPANDED;
-	TREEVIEW_SendExpanded(infoPtr, wineItem, TVE_EXPAND);
-	wineItem->state |= TVIS_EXPANDEDONCE;
     }
     else
     {
@@ -3312,6 +3310,13 @@ TREEVIEW_Expand(TREEVIEW_INFO *infoPtr, TREEVIEW_ITEM *wineItem,
         TREEVIEW_UpdateSubTree(infoPtr, wineItem);
         TREEVIEW_UpdateScrollBars(infoPtr);
 
+        if (bUser || ((wineItem->cChildren != 0) &&
+                      !(wineItem->state & TVIS_EXPANDEDONCE)))
+        {
+            TREEVIEW_SendExpanded(infoPtr, wineItem, TVE_EXPAND);
+            wineItem->state |= TVIS_EXPANDEDONCE;
+        }
+
         scrollRect.left = 0;
         scrollRect.bottom = infoPtr->treeHeight;
         scrollRect.right = infoPtr->clientWidth;
-- 
1.6.2.5

